/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-05 at 19:31:22 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * A paginated list of video categories returned as the response to a youtube.videoCategory.list
 * call.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class VideoCategoryListResponse extends com.google.api.client.json.GenericJson {

  /**
   * The ETag of the response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * Serialized EventId of the request which produced this response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String eventId;

  /**
   * A list of video categories that can be associated with YouTube videos. In this map, the video
   * category ID is the map key, and its value is the corresponding videoCategory resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<VideoCategory> items;

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoCategoryListResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The visitorId identifies the visitor.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String visitorId;

  /**
   * The ETag of the response.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * The ETag of the response.
   * @param etag etag or {@code null} for none
   */
  public VideoCategoryListResponse setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * Serialized EventId of the request which produced this response.
   * @return value or {@code null} for none
   */
  public java.lang.String getEventId() {
    return eventId;
  }

  /**
   * Serialized EventId of the request which produced this response.
   * @param eventId eventId or {@code null} for none
   */
  public VideoCategoryListResponse setEventId(java.lang.String eventId) {
    this.eventId = eventId;
    return this;
  }

  /**
   * A list of video categories that can be associated with YouTube videos. In this map, the video
   * category ID is the map key, and its value is the corresponding videoCategory resource.
   * @return value or {@code null} for none
   */
  public java.util.List<VideoCategory> getItems() {
    return items;
  }

  /**
   * A list of video categories that can be associated with YouTube videos. In this map, the video
   * category ID is the map key, and its value is the corresponding videoCategory resource.
   * @param items items or {@code null} for none
   */
  public VideoCategoryListResponse setItems(java.util.List<VideoCategory> items) {
    this.items = items;
    return this;
  }

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoCategoryListResponse.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoCategoryListResponse.
   * @param kind kind or {@code null} for none
   */
  public VideoCategoryListResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The visitorId identifies the visitor.
   * @return value or {@code null} for none
   */
  public java.lang.String getVisitorId() {
    return visitorId;
  }

  /**
   * The visitorId identifies the visitor.
   * @param visitorId visitorId or {@code null} for none
   */
  public VideoCategoryListResponse setVisitorId(java.lang.String visitorId) {
    this.visitorId = visitorId;
    return this;
  }

  @Override
  public VideoCategoryListResponse set(String fieldName, Object value) {
    return (VideoCategoryListResponse) super.set(fieldName, value);
  }

  @Override
  public VideoCategoryListResponse clone() {
    return (VideoCategoryListResponse) super.clone();
  }

}
